首页 > 代码库 > hdu 1394 Minimum Inversion Number(线段树)

hdu 1394 Minimum Inversion Number(线段树)

Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10853    Accepted Submission(s): 6676


Problem Description
The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.
 

Input
The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.
 

Output
For each case, output the minimum inversion number on a single line.
 

Sample Input
10 1 3 6 9 0 8 5 7 4 2
 

Sample Output
16
 


题解及代码:

       线段树的经典题目,用线段树来求数字序列的逆序数,这里我讲解一下程序求逆序数的思想。

       我们使用线段树的叶子节点那顺序记录第k大的数的有无,我们从开始扫描数字序列数组,每进来一个数x,就寻找它的叶子节点并标记为1,然后回溯更新线段区间,然后我们查询x进来之前比x大的数有多少个,使用query(x+1,n,1)就可以了。

      接下来就是说这道题了,我们求出序列的逆序数之后,记录为sum,然后从序列中第一个元素开始扫描,把它放到最后,这样我们会发现,当我们把它拿出来之后,逆序数会减小x-1,因为x后面比x小的数有x-1个,当把它放在最后的时候,逆序数会增加n-x,因为x前面比x大的数有n-x个。


接下来直接写就可以了:


#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <string>
#define maxn 5010
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define ALL %I64d
using namespace std;
typedef long long  ll;


struct segment
{
    int l,r;
    int value;
} son[maxn<<2];

void PushUp(int rt)
{
    son[rt].value=http://www.mamicode.com/son[rt<<1].value+son[rt<<1|1].value;>